      SUBROUTINE QS18D(RINT,A,B,F,W,FI,E,L,RA,RB,IERR)                  QS180010
         INTEGER IERR,L                                                 QS180020
         DOUBLE PRECISION A,B,E,F,FI,RA,RB,RINT,W                       QS180030
         DIMENSION RA(L),RB(L)                                          QS180040
         INTEGER INT                                                    QS180050
         DOUBLE PRECISION DABS,DSIN                                     QS180060
         EXTERNAL UTQS13                                                QS180070
         INTEGER I,I0,I1,J,K,K0,M,N,N0,N1,N2                            QS180080
         DOUBLE PRECISION A0,B0,C,E0,H,PI,Q,Q0,QJ,R,R0,R1,R2,RA1,RA2,   QS180090
     *                    RB1,RB2,RI,RJ,X,X0,X1,XA,XA0,XB,XB0           QS180100
         DIMENSION C(16),X(16)                                          QS180110
         DATA X(1),X(2),X(3),X(4),X(5),X(6),X(7),X(8),X(9),X(10),       QS180120
     1   X(11),X(12),X(13),X(14),X(15),X(16)/.4986319309247408D0,       QS180130
     2   .4928057557726342D0,.4823811277937532D0,.4674530379688698D0,   QS180140
     3   .4481605778830261D0,.4246838068662850D0,.3972418979839712D0,   QS180150
     4   .3660910593701448D0,.3315221334651076D0,.2938578786203812D0,   QS180160
     5   .2534499544661147D0,.2106756380653177D0,.1659343011410638D0,   QS180170
     6   .1196436811260685D0,.0722359807913982D0,.0241538328438692D0/   QS180180
         DATA C(1),C(2),C(3),C(4),C(5),C(6),C(7),C(8),C(9),C(10),       QS180190
     1   C(11),C(12),C(13),C(14),C(15),C(16)/.0035093050047350D0,       QS180200
     2   .0081371973654528D0,.0126960326546310D0,.0171369314565107D0,   QS180210
     3   .0214179490111133D0,.0254990296311881D0,.0293420467392678D0,   QS180220
     4   .0329111113881809D0,.0361728970544243D0,.0390969478935352D0,   QS180230
     5   .0416559621134734D0,.0438260465022019D0,.0455869393478819D0,   QS180240
     6   .0469221995404023D0,.0478193600396374D0,.0482700442573639D0/,  QS180250
     7   PI/3.141592653589793D0/                                        QS180250
       Q = W                                                            QS180260
       R = FI                                                           QS180270
       N = L                                                            QS180280
       IERR = 0                                                         QS180290
       IF (B - A) 10, 20, 30                                            QS180300
   10  CONTINUE                                                         QS180310
       A0 = B                                                           QS180320
       B0 = A                                                           QS180330
       J = -1                                                           QS180340
       GO TO 40                                                         QS180350
   20  CONTINUE                                                         QS180360
       RINT = 0.D0                                                      QS180370
       K = 0                                                            QS180380
       GO TO 240                                                        QS180390
   30  CONTINUE                                                         QS180400
       A0 = A                                                           QS180410
       B0 = B                                                           QS180420
       J = 1                                                            QS180430
   40  CONTINUE                                                         QS180440
       IF (Q .GE. 0.D0) GO TO 50                                        QS180450
          QJ = -Q                                                       QS180460
          RJ = -R                                                       QS180470
          J = -J                                                        QS180480
          GO TO 60                                                      QS180490
   50  CONTINUE                                                         QS180500
       QJ = Q                                                           QS180510
       RJ = R                                                           QS180520
   60  CONTINUE                                                         QS180530
       Q0 = QJ/PI                                                       QS180540
       R0 = RJ/PI                                                       QS180550
       R1 = Q0*A0 + R0                                                  QS180560
       N1 = INT(R1)                                                     QS180570
       IF (R1 .GE. 0.D0) N1 = N1 + 1                                    QS180580
       R2 = Q0*B0 + R0                                                  QS180590
       N2 = INT(R2)                                                     QS180600
       IF (R2 .LT. 0.D0) N2 = N2 - 1                                    QS180610
       N0 = N2 - N1                                                     QS180620
       K = N0 + 1                                                       QS180630
       IF (N0 .GE. 1) GO TO 70                                          QS180640
          H = B0 - A0                                                   QS180650
          X1 = A0 + .5D0*H                                              QS180660
          RINT = 0.D0                                                   QS180670
          ASSIGN 220 TO M                                               QS180680
          GO TO 200                                                     QS180690
   70  CONTINUE                                                         QS180700
       H = PI/QJ                                                        QS180710
       XA0 = H*N1 - RJ/QJ                                               QS180720
       XB0 = XA0 + H*N0                                                 QS180730
       IF (N0 .GE. 2) GO TO 90                                          QS180740
          X1 = XA0 + .5D0*H                                             QS180750
          ASSIGN 80 TO M                                                QS180760
          GO TO 200                                                     QS180770
   80  CONTINUE                                                         QS180780
       RINT = RI                                                        QS180790
       GO TO 170                                                        QS180800
   90  CONTINUE                                                         QS180810
       IF (K .GT. N) K = N                                              QS180820
       XA = XA0                                                         QS180830
       X1 = XA + .5D0*H                                                 QS180840
       ASSIGN 100 TO M                                                  QS180850
       GO TO 200                                                        QS180860
  100  CONTINUE                                                         QS180870
       RA(1) = RI                                                       QS180880
       RA(2) = .5D0*RI                                                  QS180890
       RA1 = RI                                                         QS180900
       XB = XB0                                                         QS180910
       X1 = XB - .5D0*H                                                 QS180920
       ASSIGN 110 TO M                                                  QS180930
       GO TO 200                                                        QS180940
  110  CONTINUE                                                         QS180950
       RB(1) = RI                                                       QS180960
       RB(2) = .5D0*RI                                                  QS180970
       RB1 = RI                                                         QS180980
       DO 150 I = 3, K                                                  QS180990
          K0 = I                                                        QS181000
          XA = XA + H                                                   QS181010
          X1 = XA + .5D0*H                                              QS181020
          ASSIGN 120 TO M                                               QS181030
          GO TO 200                                                     QS181040
  120     CONTINUE                                                      QS181050
          RA(1) = RA(1) + RI                                            QS181060
          RA(I) = RA(1)                                                 QS181070
          XB = XB - H                                                   QS181080
          X1 = XB - .5D0*H                                              QS181090
          ASSIGN 130 TO M                                               QS181100
          GO TO 200                                                     QS181110
  130     CONTINUE                                                      QS181120
          RB(1) = RB(1) + RI                                            QS181130
          RB(I) = RB(1)                                                 QS181140
          DO 140 I1 = 2, I                                              QS181150
             I0 = I1                                                    QS181160
             RA2 = RA(I1)                                               QS181170
             RA(I1) = .5D0*(RA(I1-1) + RA1)                             QS181180
             RB2 = RB(I1)                                               QS181190
             RB(I1) = .5D0*(RB(I1-1) + RB1)                             QS181200
             E0 = DABS(RA(I1) - RA1) + DABS(RA(I1-1) - RA1) +           QS181210
     1            DABS(RB(I1) - RB1) + DABS(RB(I1-1) - RB1)             QS181220
             IF (E0 .LE. E) GO TO 160                                   QS181230
                RA1 = RA2                                               QS181240
                RB1 = RB2                                               QS181250
  140        CONTINUE                                                   QS181260
  150     CONTINUE                                                      QS181270
          IERR = 65                                                     QS181280
          CALL UTQS13(IERR,15)                                          QS181290
  160  CONTINUE                                                         QS181300
       RINT = RA(I0) + RB(I0)                                           QS181310
       K = K0                                                           QS181320
  170  CONTINUE                                                         QS181330
       H = XA0 - A0                                                     QS181340
       IF (H .LE. 0.D0) GO TO 190                                       QS181350
          X1 = A0 + .5D0*H                                              QS181360
          ASSIGN 180 TO M                                               QS181370
          GO TO 200                                                     QS181380
  180  CONTINUE                                                         QS181390
       RINT = RINT + RI                                                 QS181400
  190  CONTINUE                                                         QS181410
       H = B0 - XB0                                                     QS181420
       IF (H .LE. 0.D0) GO TO 230                                       QS181430
          X1 = B0 - .5D0*H                                              QS181440
          ASSIGN 220 TO M                                               QS181450
  200  CONTINUE                                                         QS181460
       RI = 0.D0                                                        QS181470
       DO 210 I1 = 1, 16                                                QS181480
          X0 = H*X(I1)                                                  QS181490
          RI = RI + C(I1)*(F(X1+X0)*DSIN(QJ*(X1+X0) + RJ) + F(X1-X0)*   QS181500
     1         DSIN(QJ*(X1-X0) + RJ))                                   QS181510
  210  CONTINUE                                                         QS181520
       RI = H*RI                                                        QS181530
       GO TO M,(80,100,110,120,130,180,220,230)                         QS181540
  220  CONTINUE                                                         QS181550
       RINT = RINT + RI                                                 QS181560
  230  CONTINUE                                                         QS181570
       RINT = RINT*J                                                    QS181580
  240  CONTINUE                                                         QS181590
       RETURN                                                           QS181600
      END                                                               QS181610
